﻿var _NoError = 0;
var _GeneralException = 101;
var _ServerBusy = 102;
var _InvalidArgumentError = 201;
var _ElementCannotHaveChildren = 202;
var _ElementIsNotAnArray = 203;
var _NotInitialized = 301;
var _NotImplementedError = 401;
var _InvalidSetValue = 402;
var _ElementIsReadOnly = 403;
var _ElementIsWriteOnly = 404;
var _IncorrectDataType = 405;
var iFrameSrc = "";

//This is the main function of the content that will do execution of loading the content based on URI and persistent data pass in LoadSCORenderer method
function APIControl() {
	var scope = this;
	API = this;
	scope.isActive = false;
	scope.timerActive = false;
	scope.preferenceText = "{}";
	scope.APILog = [];
	scope.errorCode = 0; //default;
	scope.addDatum = function (pname) {
		scope.data.push({ name: pname, value: "", isDirty: false });
	};
	scope.loadSCO = function () {
		scope.LMSPause(true);
		if (iFrameSrc.indexOf("shell") == -1)
			$("#contentFrame").attr("src", iFrameSrc);
		else {
			var tempQueryString = '?dummy=' + new Date().getTime();
			//var newSrc = iFrameSrc.substring(0, iFrameSrc.indexOf('shell') + 10) + tempQueryString + iFrameSrc.substring(iFrameSrc.indexOf('#'), iFrameSrc.indexOf('#') + 1) + iFrameSrc.substring(iFrameSrc.indexOf('#') + 2, iFrameSrc.length);
			//https://localhost:44301/SCO/ExamContent/170662011/shell.html#/q/KA_124

			var location = iFrameSrc.substring(0, iFrameSrc.indexOf('#'));
			var question = iFrameSrc.substring(iFrameSrc.indexOf('#') + 2, iFrameSrc.length);
			var newSrc = location + tempQueryString + '#' + question;

			$("#contentFrame").attr("src", newSrc);
		}
	};
	scope.LMSGetLastError = function () { return scope.errorCode; };
	scope.LMSInitialize = function (p) {
		//scope.LogMessage("LMSInitialize", [p]);
		scope.isActive = true;
		scope.LMSPause(false);
		scope.$eval();
		scope.errorCode = 0;
		return "true";
	};
	scope.LMSGetValue = function (pname) {
		//if (!scope.LogMessage("LMSGetValue", [pname])) { return "false"; }
		var result = ""; //default
		var nvp = angular.Array.filter(scope.data, function (p) { return p.name == pname; });
		if (1 <= nvp.length) {
			if (pname == "cmi.student_preference.text" && scope.preferenceText != "{}") {
				result = scope.preferenceText;
			}
			else if (pname == "cmi.student_preference.text" && typeof nvp[0].value === 'undefined') {
				result = "{}";
			}
			else {
				result = nvp[0].value;
			}
		}
		return result; // default
	};
	scope.LMSSetValue = function (pname, pvalue) {
		//if (!scope.LogMessage("LMSSetValue", [pname, pvalue])) { return "false"; }

		var nvp = angular.Array.filter(scope.data, function (p) { return p.name == pname; });

		if (1 <= nvp.length) {
			if (pname == "cmi.student_preference.text") {
				scope.preferenceText = pvalue;
			}

			if (nvp[0].value != pvalue) {
				nvp[0].value = pvalue;
				nvp[0].isDirty = true;
			}
		}
		else {
			scope.data.push({ name: pname, value: pvalue, isDirty: true });
		}

		scope.$eval();

		return "true";
	};
	scope.LMSSetValueOnUnload = function (name, value) {
		//if (!scope.LogMessage("LMSSetValueOnUnload", [name, value])) { return ""; }

		return scope.LMSSetValue(name, value);
	};
	scope.LMSNavigateCallback = function () { }; //default to an empty function
	scope.LMSSetNavigateCallback = function (func) {
		//scope.LogMessage("LMSSetNavigateCallback", ["func"]);
		scope.LMSNavigateCallback = func;
		return "true";
	};
	scope.LMSNavigate = function () {
		if (scope.LMSNavigateCallback) {
			scope.LMSNavigateCallback(); //will be initialized to an empty function or created by the content
		}

		if (scope.isActive) {
			scope.LMSFinish("rts");
		}
		scope.$eval();
	};
	scope.LMSFinish = function (p) {
		if (scope.isActive) {
			scope.LMSCommit();
			scope.isActive = false;
		}
		//scope.LogMessage("LMSFinish", [p]);
		scope.isActive = false;
		scope.LMSPause(true);
		scope.$eval();
		return "true";
	};
	scope.LMSCommit = function (p) {
		//scope.LogMessage("LMSCommit", [p]);
		if (scope.isActive) {
			for (var i = 0; i < scope.data.length; i++) {
				var datum = scope.data[i];
				datum.isDirty = false;
			}
		}
		scope.$eval();

		return "true";
	};
	scope.LMSGetErrorString = function (p) {
		//scope.LogMessage("LMSGetErrorString", [p]);
		return "Error Code: " + this.LMSGetLastError();
	};
	scope.LMSGetDiagnostic = function (p) {
		//scope.LogMessage("LMSGetDiagnostic", [p]);
		return "Error Code: " + this.LMSGetLastError();
	};
	scope.LMSPause = function (bool) {
		//scope.LogMessage("LMSPause", [bool]);
		scope.timerActive = !bool;
		scope.isPaused = bool;

		if (bool == true) {
			PauseTimer();
		} else {
			UnPauseTimer();
		}

		return "true";
	};

	scope.LogMessage = function (f, p, m) {
		scope.APILog.push({ func: f, params: p, message: m });
		scope.$eval();
		if (!scope.isActive) {
			scope.errorCode = _NotInitialized;
			return false;
		}
		scope.errorCode = _NoError;

		return true;
	};
}

//This is Instantiate Renderer method the will call by the driver and lets the API control load the exam item based on persistent Json Data and URI parameter
function LoadSCORenderer(url, persistentJsonData) {
	ScoJSonConverter.InitializeSJSONandSD(); // Initialize temporary variables
	var jsonData = ScoJSonConverter.ParseState(jsonParse(persistentJsonData));
	iFrameSrc = url;
	API.loadSCO(url);
	//setTimeout(API.loadSCO, 1000);
	API.data = jsonData;
}

function LoadBlankPage() {
	iFrameSrc = "about:blank";
	setTimeout(API.loadSCO, 1);
}

//This method will call by the driver while client navigating the exam items.
//This will get the current state of an item. The LMSNavigate method will  trigger the APIControl to collect all the data and pack it into one JSON string.
function GetState() {
	API.LMSNavigate();
	var currentState = JSON.stringify(ScoJSonConverter.ParseResponse(API.data));
	return currentState;
}

function GetResult() {
    try {
        if (API.LMSNavigateCallback) {
            API.LMSNavigateCallback(); //will be initialized to an empty function or created by the content
        }
        API.LMSCommit();

        var currentState = JSON.stringify(ScoJSonConverter.ParseResponse(API.data));
        return currentState;
    } catch (err) {
        return '';
    }
}

//This method will call the driver next item method.
function CallDriverNextItem() {
	PerformNext();
}
