﻿/// <reference path="../../views/home/index.cshtml" />
jQuery.support.cors = true;

var secs = 0,
	totalItem = 0,
	timer;
var isTimerActive = false;
var isReviewing = false;
var examMode = "Default";
var okButton = {};
var navTypeComplex = "complex";
var isLastItemReached = false;
var isAutomated = false;
var isLeavingComment = false;

$("#timerExpiredBtn").click(function () {
    if (commentsEnabled) {
        $.ajax({
            type: 'POST',
            url: '/StartCommenting',
            success: function () {
                window.location.href = "/StartExam";
            },
            error: okEndExam
        });
    } else {
        okEndExam();
    }
});

$("#errorBtn").click(function () {
    okEndExam();
});

function okEndExam() {
    $.ajax({
        type: 'POST',
        url: '/End',
        data: { timeRemaining: secs },
        success: function () {
            window.location.href = "/Close";
        },
        error: errorEncountered
    });
};

// Determines if the render_frame exists and is visible.
// Helps with accessibility navigation.
function rendererFrameIsVisible() {
    var frame = $("#contentFrame");
    if (frame == null)
        return false;
    if (frame.css("visibility") == "hidden")
        return false;
    else
        return true;
}

function altT() {
    if (document.activeElement == document.getElementsByTagName("iframe")[0]) {
        console.log('iframe has focus');
    } else {
        console.log('iframe not focused');
    }
}

// Set focus on content.
function setFocus() {
    // If we are in the review dialog do not allow content focus since it is just hidden.
    // This is needed even with the above method becuase of issues with CEF slowness on the browser completing a page load.
    if ($("#contentFrame").css("visibility") === "hidden" || isLeavingComments) {
        console.log("contentFrame is hidden");
        return;
    }
    var focusSet = false;
    var firstFocus = document.getElementsByTagName('iframe')[0].contentWindow.document.getElementById('flash');
    if (firstFocus != null) {
        focusSet = true;
        console.log("got focus on firstFocus");
        firstFocus.focus();
    }
    else {
        var contentFrame = document.getElementsByTagName('iframe')[0];
        if (contentFrame != null) {
            console.log("got focus on contentFrame");
            contentFrame.contentWindow.focus();
            contentFrame.contentWindow.document.body.focus();
        }
        else {
            console.log("This is not hammer or flash");
        }
    }
}

$(function () {
    /*
     * this swallows backspace keys on any non-input element.
     * stops backspace -> back
     */
    var rx = /INPUT|SELECT|TEXTAREA/i;

    $(document).bind("keydown keypress", function (e) {
        if (e.which == 8) { // 8 == backspace
            if (!rx.test(e.target.tagName) || e.target.disabled || e.target.readOnly) {
                e.preventDefault();
            }
        }
    });
});

var getRating = function () {
    return $("input:radio:checked").val();
}

$(document).ready(function () {
    $.ajax({
        type: 'GET',
        url: '/Home/LoadFirstItem',
        success: function (data) {
            isAutomated = data.IsAutomated;
            var isHammer = data.URI.match(/shell/i);
            if (!isHammer) {
                timerPaused++;
            }
            if (data.totalInvolvedSec >= data.TotalSeconds) {
                endExam();
            }
            LoadSCORenderer(data.URI, data.ItemState);
            // Set navigation display
            totalItem = data.TotalItem;
            $('#chkMarkForReview').prop('checked', data.MarkForReview);
            $('#chkCommentLater').prop('checked', data.CommentLater);
            $('#btnNext').show();//.css('visibility', 'visible');
            navigate(data.CurrentItemNo, data.PreviousNavigationAvailable, data.IsMenuReached, data.Count, data.PageType);

            //For debug mode
            $('.question').html('Question: ' + data.URI);

            // Initialize timer
            secs = data.timeRemaining;
            setFocus();

            $('#itemCommentText').val(data.Comments);
            if (data.IsLeavingComments) {
                $('#itemComment_dialog').dialog('open');
            }
        },
        error: errorEncountered
    });

    /* Accessibility Compliance  Region */

    $("#counter, #itemNavigation, #reviewButtonTemp").focusin(function () {
        $(this).addClass("driverFocus");
    });

    $("#counter, #itemNavigation, #reviewButtonTemp").focusout(function () {
        $(this).removeClass("driverFocus");
    });

    $("#counter, #itemNavigation").on({
        mouseenter: function () {
            $(this).addClass("driverFocus");
        },
        mouseleave: function () {
            $(this).removeClass("driverFocus");
        }
    });

    $("#chkMarkForReview").focusin(function () {
        $("#lblMarkForReview").addClass("driverFocus");
    });

    $("#chkMarkForReview").focusout(function () {
        $("#lblMarkForReview").removeClass("driverFocus");
    });

    $("#chkMarkForReview, #lblMarkForReview").on({
        mouseenter: function () {
            $("#lblMarkForReview").addClass("driverFocus");
        },
        mouseleave: function () {
            $("#lblMarkForReview").removeClass("driverFocus");
        }
    });

    $("#btnNext, #btnPrevious, #btnMenu, #reviewButtonTemp, #btnItemComment").on({
        mouseenter: function () {
            $(this).removeClass().addClass("ui-button driverButtonFocus");
            $(this).css("color", "white");
        },
        mouseleave: function () {
            if (highContrast) {
                $(this).removeClass("ui-priority-primary driverButtonFocus").addClass("buttonHighContrast");
            }
            else {
                $(this).removeClass("driverButtonFocus").addClass("ui-button ui-priority-primary medium");
            }
        }
    });

    $("#tblItems a").removeClass();

    if (highContrast)
        createHighContrast();

    /* End of Accessibility Compliance  Region */

    /* Debug Region */

    $("#btnDebugTenSecondsLeft").click(function () {
        $('#divDebugModeContainer').hide();
        if (isTimerActive == true) {
            isTimerActive = false;
            pauseTimer();
        }
        startTimer(10);
    });

    $("#btnDebugTimeLeft").click(function () {
        $('#divDebugModeContainer').hide();
        if (isTimerActive == true) {
            isTimerActive = false;
            pauseTimer();
        }
        startTimer($("#txtTimeLeft").val() * 1 == 0 ? 60 : $("#txtTimeLeft").val() * 60);
    });

    $("#btnDebugReviewPage").click(function () {
        $('#divDebugModeContainer').hide();
        $('#btnMenu').click();
    });

    $("#btnGoto").click(function () {
        $('#divDebugModeContainer').hide();
        returnToQuestion($("#txtQuestion").val());
    });

    $("#btnDebugFocus").click(function () {
        $('#divDebugModeContainer').hide();
        setTimeout(setFocus, 100);
    });

    $('#btnGetResult').click(function () {
        var itemState = GetResult();
        $.ajax({
            type: 'POST',
            url: '/Home/GetResultForDebug',
            data: itemState,
            success: function (data) {
                $('#txtDebugStatus').val(data.Status);
                $('#txtDebugRawScore').val(data.Score);
                $('#txtDebugWeight').val(data.Weight);
                $('#txtDebugState').val(JSON.stringify(JSON.parse(data.State).RestoreState));
            },
            error: errorEncountered
        });
    });

    //True for enable (default), false for disable
    var enableNavigationButtons = function (enable) {
        if (enable === undefined) {
            enable = true;
        }
        $('#btnNext').attr('disabled', !enable);
        $('#btnPrevious').attr('disabled', !enable);
    }


    $('#btnNext, #commentingNext').click(function () {
        //**Not sure if this code is still functional (should not be possible to be true)
        if (isLastItemReached) {
            $('#btnMenu').click();
            return;
        }
        //**End uncertanty
        enableNavigationButtons(false);
        try {
            var itemState = JSON.parse(GetResult());
            itemState.userComments = $('#itemCommentText').val();
            itemState.userRating = getRating();
            itemState = JSON.stringify(itemState);
            $.ajax({
                type: 'POST',
                url: '/Home/NextItem?timeRemaining=' + secs,
                data: itemState,
                success: function (data) {
                    if (data.LastItemReached == true) {
                        if (isAutomated || reviewDisabled || isSurvey) {
                            okEndExam();
                        } else {
                            $('#btnMenu').click();
                        }
                    } else {
                        isLastItemReached = data.IsLastItem;
                        window.location.href = "/StartExam";
                    }
                    setFocus();
                },
                error: errorEncountered
            });
        } catch (ex) {
            console.error("Unable to navigate next", ex);
            enableNavigationButtons(true);
        }
    });

    $('#btnPrevious').click(function () {
        enableNavigationButtons(false);
        try {
            var itemState = GetResult();
            $.ajax({
                type: 'POST',
                url: '/Home/PreviousItem?timeRemaining=' + secs,
                data: itemState,
                success: function (data) {
                    isLastItemReached = data.IsLastItem;
                    window.location.href = "/StartExam";
                },
                error: errorEncountered
            });
        } catch (ex) {
            console.error("Unable to navigate next", ex);
            enableNavigationButtons(true);
        }
    });

    $('#btnDebugStateOverride').click(function () {
        //GetResult returns a string, but we only want to override one part of that string
        //so we are converting it to an object
        var itemState = JSON.parse(GetResult());
        //Pull the new state that we want to override. Parse it. Let it fail if it's invalid - Debug only tool
        var newState = JSON.parse($('#txtDebugState').val());
        itemState.RestoreState = newState;
        $.ajax({
            type: 'POST',
            url: '/Home/GetResultForDebug?timeRemaining=' + secs,
            data: JSON.stringify(itemState),
            success: function (data) {
                if (data.LastItemReached == true) {
                    $('#btnMenu').click();
                }
                else {
                    window.location.href = "/StartExam";
                }
                setFocus();
            },
            error: errorEncountered
        });
    })

    $('#chkMarkForReview').click(function () {
        var isChecked = $(this).is(':checked');
        $.ajax({
            type: 'POST',
            url: '/Home/MarkItemForReview?isCheck=' + isChecked,
            success: function () { },
            error: errorEncountered
        });
    });

    $('#chkCommentLater').click(function () {
        var isChecked = $(this).is(':checked');
        $.ajax({
            type: 'POST',
            url: '/Home/CommentLater?isCheck=' + isChecked,
            success: function () { },
            error: errorEncountered
        });
    });

    $('#itemComment_dialog').dialog({
        closeOnEscape: false,
        autoOpen: false,
        modal: true,
        width: 630,
        minWidth: 780,
        minHeight: 415,
        dialogClass: "noclose"
    });

    $('#timerexpired_dialog').dialog({
        closeOnEscape: false,
        autoOpen: false,
        modal: true,
        dialogClass: "noclose"
    });

    $("#error_dialog").dialog({
        closeOnEscape: false,
        autoOpen: false,
        modal: true,
        dialogClass: "noclose"
    });

    // Review Page Dialog
    $('#review_dialog')
        .dialog({
            closeOnEscape: false,
            autoOpen: false,
            resizable: false,
            draggable: false,
            width: $(window).width() * .9,
            height: $(window).height() * .9,
            position: 'top',
            dialogClass: "noclose reviewButton examSummary",
            buttons: [{
                id: "reviewButtonTemp",
                text: reviewExit,
                click: function () {
                    $.ajax({
                        type: 'POST',
                        url: '/End?timeRemaining=' + secs,
                        data: { timeRemaining: secs },
                        success: function () {
                            window.location.href = "/Close";
                        },
                        error: errorEncountered
                    });
                }
            }, {
                id: "commentButtonTemp",
                text: reviewCommentButton,
                click: function () {
                    $.ajax({
                        type: 'POST',
                        url: '/StartCommenting',
                        success: function () {
                            window.location.href = "/StartExam";
                        },
                        error: errorEncountered
                    });

                }
            }]
        }
);

    $("#reviewButtonTemp").prop('title', reviewExit);
    $("#reviewButtonTemp").prop('tabindex', "0");

    $('#btnMenu, #commentingMenu').click(function () {
        if (isTimerActive == true) {
            isTimerActive = false;
            pauseTimer();
        }
        $('#commentLater').hide();

        $('#divDebugModeContainer').hide();
        var navType = '';
        var itemState = JSON.parse(GetResult());
        itemState.userComments = $('#itemCommentText').val();
        itemState.userRating = getRating();
        itemState = JSON.stringify(itemState);
        $.ajax({
            type: 'POST',
            dataType: 'json',
            url: '/Home/LoadItems?timeRemaining=' + secs,
            data: itemState,
            success: function (data) {
                isLeavingComment = data.IsLeavingComments;
                navType = data.NavType;
                $('#contentFrame').css('visibility', 'hidden');
                //$('#contentFrame').css({ "height": "0", "width": "0", "border": "none" });
                $('#tblItems tr:gt(0)').remove();
                $.each(data.ItemList,
                    function (idx, val) {
                        var row = $('<tr>');
                        var questionTitle = questionLabel + " " + (idx + 1); //TODO: DLN - NOT HARDCODED "QUESTION"!!! 

                        if (highContrast) {
                            var returnToQuestionColor = "yellow";
                            if (idx % 2 == 0) {
                                var questionStyle = " style = \"color:white\" ";
                            } else {
                                questionStyle = " style = \"color:black\" ";
                            }
                        } else {
                            questionStyle = "";
                            returnToQuestionColor = "#0069d6";
                        }
                        row.append($('<td ' +
                                questionStyle +
                                'title="' +
                                questionTitle +
                                //'" tabindex="0" aria-label="' +
                                //questionTitle +
                                '">')
                            .html(questionTitle)); //idx + 1));
                        var markForReview = '';
                        var returnToQuestion = '';

                        var ariaLabel = returnLabel + ' ' + (idx + 1);
                        if (val.MarkForReview) {
                            ariaLabel += ' ' + legendMarkForReview;
                        }
                        if (val.MarkedForComment) {
                            ariaLabel += ' ' + legendMarkForComment;
                        }




                        if (val.MarkForReview) {
                            markForReview = '<img src=\"../Content/images/note.png\" alt=\"' +
                                questionTitle +
                                ' Marked for Review" title=\"' +
                                questionTitle +
                                ' Marked for Review" >';
                            returnToQuestion = '<a href="javascript:;" onclick="returnToQuestion(' + val.ItemID + ')"' +
                                questionStyle + ' title="' + returnLabel + ' ' + (idx + 1) + '" aria-label="' + ariaLabel + '" tabindex="0" >' +
                                returnLabel +
                                '</a>';
                            row.append($('<td tabindex="-1">').html(markForReview));
                        } else {
                            returnToQuestion = '<a href="javascript:;" onclick="returnToQuestion(' +
                                val.ItemID +
                                ')"' +
                                questionStyle +
                                ' title="' +
                                returnLabel +
                                ' ' +
                                (idx + 1) +
                                '" aria-label="' + ariaLabel +
                                '" tabindex="0">' +
                                returnLabel +
                                '</a>';
                            row.append($('<td tabindex="-1">').html(markForReview));
                        }

                        var status = '';
                        // Set the status icons for a complex navType
                        if (navType == navTypeComplex) {
                            $('#statusCol').attr('colSpan', 2);
                            if (val.AttemptCount == 0) {
                                if (val.ItemState != '') {
                                    if (val.LessonStatus == 'incomplete') {
                                        status = '<img src=\"../Content/images/incomplete.png\">';
                                    } else {
                                        status = '<img src=\"../Content/images/not-attempted.png\">';
                                    }
                                } else {
                                    status = '<img src=\"../Content/images/not-attempted.png\">';
                                }
                            } else {
                                if (val.ItemState != '') {
                                    if (val.LessonStatus == 'incomplete') {
                                        status = '<img src=\"../Content/images/incomplete.png\">';
                                    } else {
                                        status = '<img src=\"../Content/images/completed.png\">';
                                    }
                                } else {
                                    status = '<img src=\"../Content/images/completed.png\">';
                                }
                            }
                        } else if (!commentsEnabled) {
                            // a simple navType would show no status icons
                            $('#statusCol').attr('colSpan', 1);
                        }
                        if (val.MarkedForComment) {
                            status +=
                                '&nbsp;&nbsp;&nbsp;&nbsp;<i class="fa fa-comment" style="font-size: 20px;" aria-hidden="true"></i>';
                        } else if (commentsEnabled) {
                            status +=
                                '&nbsp;&nbsp;';
                        }

                        if (status != '') {
                            row.append($('<td>').html(status));
                        }

                        if (val.MarkForReview) {
                            row.append($('<td aria-label="' + returnLabel + ' ' + (idx + 1) + '" tabindex="-1">')
                                .html(returnToQuestion));
                        } else {
                            row.append($('<td style="color:' +
                                    returnToQuestionColor +
                                    '" aria-label="' +
                                    returnLabel +
                                    ' ' +
                                    (idx + 1) +
                                    '" tabindex="-1">')
                                .html(returnToQuestion));
                        }
                        if (examMode == "Debug") {
                            row.append($('<td>').html(val.Ident));
                            row.append($('<td>').html(val.Url));
                        }

                        $('#tblItems').append(row);
                    });

                // If we are in High Contrast mode set the color to white for table heading.
                if (highContrast) {
                    $('#tblItems th').css({ "color": "white" });
                }

                $("#tblItems a")
                    .focusin(function () {
                        $(this).closest("td").addClass("parentTD");
                    });

                $("#tblItems a")
                    .focusout(function () {
                        $(this).closest("td").removeClass("parentTD");
                    });


                $('#divWhiteLabel').hide();
                $('#btnPrevious').hide();
                $('#btnNext').hide();
                $('#btnMenu').hide();
                $('#divNavigation').hide();
                $('#questionNumber').hide();
                $('#review_dialog').dialog('option', 'title', data.ProgramTitle);
                $('#review_dialog').dialog('open');
                $('#review_dialog').parent().css("margin-top", "10px");
                if (!commentsEnabled || data.IsCommenting || !data.UserWantsToLeaveFeedback) {
                    $('#commentButtonTemp').hide();
                }

                setTimeout($('#ui-id-3').focus(), 123);

                var commentLegend = '';
                if (commentsEnabled) {
                    commentLegend =
                        '&nbsp;&nbsp;&nbsp;&nbsp;<i class="fa fa-comment" style="font-size: 20px;" aria-hidden="true"></i>&nbsp;&nbsp;' + legendMarkForComment;
                }

                if ($('#legend').length == 0) {
                    if (navType == navTypeComplex) {
                        $('<div id="legend" align="center"><img src="../Content/images/note.png" />&nbsp;&nbsp;' +
                                legendMarkForReview +
                                commentLegend +
                                '&nbsp;&nbsp;&nbsp;&nbsp;<img src="../Content/images/not-attempted.png" />&nbsp;&nbsp;' +
                                legendNotAnswered +
                                '&nbsp;&nbsp;&nbsp;&nbsp;<img src="../Content/images/completed.png" />&nbsp;&nbsp;' +
                                legendAnswered +
                                '&nbsp;&nbsp;&nbsp;&nbsp;<img src="../Content/images/incomplete.png" />&nbsp;&nbsp;' +
                                legendIncomplete +
                                '</div>')
                            .insertAfter('#review_dialog');
                    } else {
                        $('<div id="legend" align="center"><img src="../Content/images/note.png" />&nbsp;&nbsp;' +
                                legendMarkForReview + commentLegend +
                                '</div>')
                            .insertAfter('#review_dialog');
                    }
                }
                setFocus();
                if (isTimerActive == false) {
                    isTimerActive = true;
                    startTimer(secs);
                }
            }
        });

        isReviewing = true;
        return false;
    });

    // Set Debug mode
    $.ajax({
        type: 'GET',
        url: '/Home/GetExamMode',
        success: function (data) {

            examMode = data.ExamMode;

            if (examMode == "Debug") {

                $("#counter").css("cursor", "pointer");
                $('#counter').click(function () {
                    $('#divDebugModeContainer').slideToggle("slow");
                    clearTimeout(timer);
                });
            } else {
                $('.question').hide();
            }
        },
        error: errorEncountered
    });



});

// After focus version 2.
function DoBlurV2(element) {
    if (highContrast) {
        $(element).removeClass("ui-priority-primary driverButtonFocus").addClass("buttonHighContrast");
    }
    else {
        $(element).removeClass().addClass("ui-button ui-priority-primary medium");
    }
}

function returnToQuestion(itemId) {
    isReviewing = false;
    LoadBlankPage();
    var questionURL = '/Home/ReturnToQuestion?itemId=' + itemId + '&timeRemaining=' + secs;
    $.ajax({
        type: 'POST',
        url: questionURL,
        data: { itemId: itemId, timeRemaining: secs },
        success: function (data) {
            window.location.href = "/StartExam";
        },
        complete: function () {
            $('#contentFrame').css('visibility', 'visible');
            //$('#contentFrame').css({ width:"100%",height:"95%" });
        },
        error: errorEncountered
    });
}

function endExam() {
    $('#contentFrame').css('visibility', 'hidden');
    $.ajax({
        type: 'POST',
        url: '/Home/EndExam?timeRemaining=' + secs,
        data: { timeRemaining: secs },
        success: function (data) {

            if (data.Success) {
                $('#timerexpired_dialog').dialog('open');
                $('#btnNext').attr('disabled', true);
                $('#btnMenu').attr('disabled', true);
                $('#btnPrevious').attr('disabled', true);
                $('#chkMarkForReview').attr('disabled', true);
            }
        },
        error: errorEncountered
    });
}

function errorEncountered() {
    $.ajax({
        type: 'POST',
        url: '/Home/ExamError',
        success: function (data) {

            if (data.Success) {

                $('#error_dialog').dialog('open');
            }
        }
    });
}

// Navigation
function navigate(currentItemNo, previousNavigationAvailable, fromMenu, countItems, pageType) {
    $('#itemNavigation').text(currentItemNo + ' / ' + totalItem);
    $('#itemNavigation').prop('title', currentItemNo + ' / ' + totalItem); // Accessibility tooltip.
    $('#itemNavigation').prop('aria-label', currentItemNo + ' / ' + totalItem); // Accessibility Navigator on focus. not sure this is working now...

    if (fromMenu) {
        $('#btnNext').hide();
        $('#btnPrevious').hide();//.css('visibility', 'hidden');
        $('#btnMenu').show();//.css('visibility', 'visible');
        return;
    }

    if (previousNavigationAvailable == true && currentItemNo > 1) {
        $('#btnPrevious').show();
    } else {
        $('#btnPrevious').hide();
    }
    $('#btnMenu').hide();
    $('#btnNext').show();//.css('visibility', 'visible');
}

// Timer Related Functions //
function checkPauseTimer() {
    if (isTimerActive == true && isReviewing == false) {
        isTimerActive = false;
        pauseTimer();
    }
}

function checkUnpauseTimer() {
    $('#btnNext').removeAttr('disabled');
    $('#btnPrevious').removeAttr('disabled');
    $('#btnMenu').removeAttr('disabled');

    if (isTimerActive == false) {
        isTimerActive = true;
        startTimer(secs);
    }
    setFocus();
}


function PauseTimer() {
    checkPauseTimer();
    $.ajax({
        type: 'GET',
        url: '/TimerStoped',
        success: function (data) {
        }
    });
    timerPaused++;
}
//Count the number of times that the pause timer function has been called by content or the LMS API
//.. Automation will use this because hammer calls Pause and unPause once before content has loaded and once after - We care about the after
var timerPaused = 0;

function UnPauseTimer() {
    checkUnpauseTimer();
    $.ajax({
        type: 'GET',
        url: '/TimerStarted',
        success: function (data) {
        }
    });
    setFocus();
    //If running automation, simulate clicking the next button after content has loaded.
    if (isAutomated && timerPaused > 1) {
        //Flash Items aren't always completely loaded when they call UnPause
        setTimeout(clickNext, 250);
    }
}

function clickNext() {
    $('#btnNext').click();
}

function pauseTimer() {
    if (typeof timer != "undefined") {
        clearTimeout(timer);
    }
}

function startTimer(endTime) {
    if (endTime >= 0) {
        secs = endTime;
        var time = secondsToTime(secs);
        $('#counter').text(time);
        timer = setTimeout(function () { startTimer(secs - 1); }, 1000);
    }
}

function secondsToTime(secs) {
    if (secs > 0) {
        var hours = Math.floor(secs / (60 * 60));

        var divisorForMinutes = secs % (60 * 60);
        var minutes = Math.floor(divisorForMinutes / 60);

        var divisorForSeconds = divisorForMinutes % 60;
        var seconds = Math.ceil(divisorForSeconds);

        if (seconds % 30 === 0) {
            $("#counter")
                .attr('aria-label',
                    navigationADATimer.f(hours, minutes, seconds));
        }

        return pad(hours, 2) + ':' + pad(minutes, 2) + ':' + pad(seconds, 2);
    }
    else if (secs == 0) {
        endExam();
    }
    return '00:00:00';
}

function pad(number, length) {
    var str = '' + number;
    while (str.length < length) { str = '0' + str; }
    return str;
}

String.prototype.format = String.prototype.f = function () {
    var s = this,
        i = arguments.length;

    while (i--) {
        s = s.replace(new RegExp('\\{' + i + '\\}', 'gm'), arguments[i]);
    }
    return s;
};